	.module crt0
	.globl	_main

	.area	_HEADER (ABS)
	.org 	0
	; turn page RAM at #0000
    ld      bc,#0x21AF      ; MEMCONFIG
    ld      a,#0x0E         ; W0RAM | W0MAP_N | W0WE
    out     (c), a
    jp      init


	.org	0x10
	ei
	ret
	.org	0x18
	reti
	.org	0x20
	reti
	.org	0x28
	reti
	.org	0x30
	reti
	.org	0x38
	ei
	ret

	.org	0x100
init:
	ld      sp,#0xC000
    ld      bc,#0x20AF  ; SYSCONFIG
    ld      a,#0x06     ; ZCLK14 | CACHEEN
    out     (c), a

    ld      b,#0x10
    xor     a
    out     (c), a      ; PAGE0 = 0


    ; set RAM pages sequentially
    ld      b,#0x11
    ld      a,#5
    out     (c), a      ; PAGE1 = 1
    inc     b
    ld      a,#2
    out     (c), a      ; PAGE2 = 2
    ld      a,#0xF6
    inc     b
    out     (c),a       ; PAGE3 = 0xF6

    ld      bc,#0x01AF
    ld      a,#0xF6
    out     (c),a

    ld      b,#0
    ld      a,#0x83
    out     (c),a

	im  1

	call    _main

$1:	halt
	jr  $1

	;; Ordering of segments for the linker.
	.area	_HOME
	.area	_CODE
	.area	_INITIALIZER
	.area   _GSINIT
	.area   _GSFINAL

	.area	_DATA
	.area	_INITIALIZED
	.area	_BSEG
	.area   _BSS
	.area   _HEAP

	.area   _CODE

	.area   _GSINIT

	.area   _GSFINAL
